#!/usr/bin/env python
# -*- coding: utf-8 -*-

#License GPL
#amk.py
#Version 0.3
#Author Fabrizio Ruggeri
#Contact: fabrizio.ruggeri@gmail.com
#Site: ramielinux.wordpress.com

from qt import *
import sys
import os
#from form import AmuleKform

class AmuleKform(QWidget):
    def __init__(self,parent = None,name = None,fl = 0):
        QWidget.__init__(self,parent,name,fl)

        if not name:
            self.setName("Form1")


        Form1Layout = QGridLayout(self,1,1,11,6,"Form1Layout")

        layout13 = QVBoxLayout(None,0,6,"layout13")

        self.textLabel1 = QLabel(self,"textLabel1")
        layout13.addWidget(self.textLabel1)

        layout11 = QHBoxLayout(None,0,6,"layout11")

        self.checkBox1 = QCheckBox(self,"checkBox1")
        layout11.addWidget(self.checkBox1)

        self.checkBox2 = QCheckBox(self,"checkBox2")
        layout11.addWidget(self.checkBox2)
        spacer3 = QSpacerItem(600,21,QSizePolicy.Expanding,QSizePolicy.Minimum)
        layout11.addItem(spacer3)
        layout13.addLayout(layout11)

        self.listView1 = QListView(self,"listView1")
        self.listView1.addColumn(self.__tr("File Name"))
        self.listView1.addColumn(self.__tr("Ed2k Link"))
        layout13.addWidget(self.listView1)

        layout12 = QHBoxLayout(None,0,6,"layout12")

        self.sendButton = QPushButton(self,"sendButton")
        layout12.addWidget(self.sendButton)

        self.progressBar2 = QProgressBar(self,"progressBar2")
        self.progressBar2.setEnabled(0)
        layout12.addWidget(self.progressBar2)

        self.textLabel1_2 = QLabel(self,"textLabel1_2")
        self.textLabel1_2.setEnabled(0)
        layout12.addWidget(self.textLabel1_2)
        spacer6 = QSpacerItem(320,39,QSizePolicy.Expanding,QSizePolicy.Minimum)
        layout12.addItem(spacer6)

        self.exitButton = QPushButton(self,"exitButton")
        layout12.addWidget(self.exitButton)
        layout13.addLayout(layout12)

        Form1Layout.addLayout(layout13,0,0)

        self.languageChange()

        self.resize(QSize(950,660).expandedTo(self.minimumSizeHint()))
        self.clearWState(Qt.WState_Polished)

        self.connect(self.exitButton,SIGNAL("clicked()"),self.close)


    def languageChange(self):
        self.setCaption(self.__tr("Form1"))
        self.textLabel1.setText(self.__tr("<b>Extracetd ed2k link<font size=\"+1\"></font></b>"))
        self.checkBox1.setText(self.__tr("&Check/Uncheck All"))
        self.checkBox1.setAccel(QKeySequence(self.__tr("Alt+C")))
        self.checkBox2.setText(self.__tr("Check/&Uncheck Selected"))
        self.checkBox2.setAccel(QKeySequence(self.__tr("Alt+U")))
        self.listView1.header().setLabel(0,self.__tr("File Name"))
        self.listView1.header().setLabel(1,self.__tr("Ed2k Link"))
        self.sendButton.setText(self.__tr("Send to &aMule"))
        self.sendButton.setAccel(QKeySequence(self.__tr("Alt+A")))
        self.textLabel1_2.setText(self.__tr("<b>Succesfully Sended</b>"))
        self.exitButton.setText(self.__tr("E&xit"))
        self.exitButton.setAccel(QKeySequence(self.__tr("Alt+X")))


    def selectAllNone(self):
        print "AmuleKform.selectAllNone(): Not implemented yet"

    def __tr(self,s,c = None):
        return qApp.translate("AmuleKform",s,c)

#Questa classe eredita il form creato col designer
class MyForm(AmuleKform):
	
	itemNumber = 0
	def __init__(self):
		AmuleKform.__init__(self)
		"""Some initialization:
		The checkbox are showed,the signla/slot setted and the selection mode permit a multiselection
		"""
		self.checkBox1.setChecked(True)
		self.checkBox1.show()
		self.checkBox2.show()
		self.listView1.setSelectionMode(QListView.Extended)
		self.connect(self.sendButton,SIGNAL('clicked()'), self.sendToMule)
		self.connect(self.checkBox1,SIGNAL("toggled(bool)"),self.checkAllNone)
		self.connect(self.checkBox2,SIGNAL("toggled(bool)"),self.checkSelected)
				
	#Aggiungiamo un funzione per inserire elementi nel form che prende due stringhe
	"""This function insert item in the list giving name and link  """
	def fillListView(self,nome,elink):
		item = QCheckListItem(self.listView1,"Selected",QCheckListItem.CheckBox)
		item.setText(0,nome+"  ")
		item.setText(1,elink)
		item.setOn(True)
		
	"""This set Geometry"""
	def adjust(self):
		self.adjustSize()
		self.itemNumber = self.itemNumber + 1
		self.progressBar2.setTotalSteps(self.itemNumber)
		
		
	"""This iter any item with QListViewItemIterator and check all/none based on checkbox1 state"""
	def checkAllNone(self):
		itemList=QListViewItemIterator(self.listView1)
		i=0
		while (itemList.current()):
			i += 1
			if ( self.checkBox1.isOn() == True ):
				itemList.current().setOn(True)
			else:
				itemList.current().setOn(False)
			itemList += 1
	
	"""This iter any selected item with QListViewItemIterator and check/uncheck all based on checkbox2 state"""
	def checkSelected(self):
		itemList=QListViewItemIterator(self.listView1)
		i=0
		while (itemList.current()):
			i += 1
			if ( itemList.current().isSelected() == True ) and (self.checkBox2.isOn() == True):
				itemList.current().setOn(True)
			else:
				itemList.current().setOn(False)
			itemList += 1
		
	
	"""This read ed2k link of checked item and send it to aMule by amule_emc.It also incremente progressbar """
	def sendToMule(self):
		self.progressBar2.setEnabled(1)
		itemList=QListViewItemIterator(self.listView1)
		i=0
		while (itemList.current()):
			i += 1
			if ( itemList.current().isOn() == True ):
				os.popen('ed2k \"'+itemList.current().text(1).__str__().encode('utf8')+'\"')
			self.progressBar2.setProgress(i)
			itemList += 1
		self.textLabel1_2.setEnabled(1)
			
		
	


if __name__ == "__main__":
	app = QApplication(sys.argv)
	myf = MyForm()

#Vediamo se il file e' binario o di testo
	f = os.popen('file -bi '+sys.argv[1],'r')
	if (f.read().find('text') != -1) == False :
	#in questo caso il file e' binario e dobbiamo darlo in pasto a amule_emc
		print sys.argv[1].replace(" ","\ ");
		os.popen('amule_emc '+ sys.argv[1].replace(" ","\ ") +'>'+os.path.expanduser('~')+"/.deleteMe")
		try:
			binaryfile = open (os.path.expanduser('~')+"/.deleteMe")   
	#Apre il file creato dallo script
		except IOError:
			os.popen('kdialog --error \"I can\'t read this collection file\\nCheck if it\'s corrupted\"')
			quit()
		try:    #Estrae nome del file e link e le aggiunge al form come elementi
			for link in binaryfile:
				name = link[link.find("ed2k://|file|")+13:link.find("|",link.find("ed2k://|file|")+13)]
				myf.fillListView(name,link)
			myf.adjust()
		finally:
			binaryfile.close()
	#Se invece non è binario	
	else:
		try:
			textfile = open(sys.argv[1],'r')
		except IOError:
			os.popen('kdialog --error \"I can\'t read this collection file\\nCheck if it\'s corrupted\"')
			quit()
		try:
			for link in textfile:
				name = link[link.find("ed2k://|file|")+13:link.find("|",link.find("ed2k://|file|")+13)]
				myf.fillListView(name,link)
			myf.adjust()
		finally:
			textfile.close()
	
	f.close()
	
	
	myf.show()
	app.setMainWidget(myf)
	app.exec_loop()